// import 'package:flutter/widgets.dart';
// import 'package:meta_forms/m_entity/model/m_schema_definition.dart';
// import 'package:meta_forms/m_entity/model/m_schema_property.dart';
// import 'package:sunny_sdk_core/sunny_sdk_core.dart'; import 'package:m_entity/m_entity.dart';
// import 'package:sunny_dart/sunny_dart.dart';
// import 'package:sunny_forms/form_fields/select_field.dart';
// import 'package:sunny_forms/meta/meta_form_context.dart';
// import 'package:sunny_forms/meta/meta_property_handler.dart';
// import 'package:sunny_forms/sdk/contact_v2/model/contact.dart' as mverse;
// import 'package:sunny_forms/sdk/m_entity/m_entity.dart';
// import 'package:sunny_forms/sdk/shared/m_model.dart';
// import 'package:sunny_forms/sdk/sunny/model/contact.dart';
// import 'package:sunny_forms/sdk/sunny/model/contact.dart' as sunny;
// import 'package:sunny_forms/service/options/contact_mkey_handler.dart';
// import 'package:sunny_forms/sunny/interactions/select_option.dart';
// import 'package:sunny_forms/sunny_form_field.dart';
//
// import '../meta_field_config.dart';
//
// class ContactLinkOptionHandler extends MetaPropertyHandler<MKey> {
//   final ContactMKeyOptionsHandler handler;
//   ContactLinkOptionHandler(this.handler);
//
//   @override
//   Iterable<Widget> renderProperty(
//     BuildContext context,
//     MetaFormContext metaForm,
//     HandledPaths paths,
//     SunnyFormFieldState<MKey> state, {
//     Key key,
//   }) {
//     final prop = paths.property as RefProperty;
//
//     const viewHandler = ContactKeyOptionViewHandler();
//     final fullPath = paths.fullPath<MKey>();
//     final fieldContext = metaForm.prop(paths.property);
//     final config = fieldContext.formConfig() ?? MetaFieldConfig.of();
//
//     return [
//       OptionSelectorControl<MKey, Contact>(
//         key: Key("field-$fullPath"),
//         handler: handler,
//         focusNode: state.focusNode,
//         isRequired: prop.isRequired == true,
//         noOptionsLabel: viewHandler.noOptionsLabel,
//         onChange: (KeyedOption<MKey, Contact> value, source) {
//           state.updateValue(value?.key, source);
//         },
//         enabled: config.isEnabled,
//         expected: (option) => option?.key,
//         onError: (error) => state.error = error,
//         initialKeyValue: state.value,
//         viewHandler: viewHandler,
//       ),
//     ];
//   }
//
//   @override
//   Iterable<HandledPaths> acceptProperties(JsonPath basePath,
//       IMSchemaDefinition definition, Map<JsonPath, IMSchemaProperty> available) {
//     return [
//       for (final v in available.values)
//         if (v is RefProperty && _contactRefsTypes.contains(v.theRef))
//           HandledPaths.ofProperty(v, basePath, this),
//     ];
//   }
// }
//
// final _contactRefsTypes = {
//   sunny.ContactRef,
//   mverse.ContactRef,
// };
