import 'package:flutter/widgets.dart';
import 'package:sunny_forms/sunny_colors.dart';

class ErrorMessage extends StatelessWidget {
  final String message;

  const ErrorMessage(this.message, {Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) => Center(
        child: Text(
          message,
          textAlign: TextAlign.center,
          style: SunnyTextStyles.errorText.copyWith(fontSize: 16),
        ),
      );
}
