import 'package:sunny_dart/sunny_dart.dart';

class MuseArgs {
  final String museId;
  final int start;

  MuseArgs({required this.museId, this.start = 0});
  factory MuseArgs.ofUri(String url) {
    final parsed = Uri.tryParse(url)!;
    parsed.pathSegments.last;
    final museId = parsed.pathSegments.last.split("-").first;
    final start = (parsed.queryParameters["start"] ?? "0").toInt();
    return MuseArgs(museId: museId, start: start ?? 0);
  }
}
