// import 'package:flutter/widgets.dart';
// import 'package:sunny_forms/attribute_form_field.dart';
// import 'package:sunny_forms/core_extensions.dart';
// import 'package:sunny_forms/form_fields/select_field.dart';
// import 'package:sunny_forms/helpers/providers.dart';
// import 'package:sunny_forms/meta/meta_form_context.dart';
// import 'package:sunny_forms/meta/meta_property_handler.dart';
// import 'package:sunny_forms/model/contactables.dart';
// import 'package:meta_forms/m_entity/model/m_schema_definition.dart';
// import 'package:meta_forms/m_entity/model/m_schema_property.dart';
// import 'package:sunny_forms/sdk/shared/definitions.dart';
// import 'package:sunny_dart/sunny_dart.dart';
// import 'package:sunny_forms/service/options/options_service.dart';
// import 'package:sunny_forms/service/options/options_view_service.dart';
// import 'package:sunny_forms/sunny/interactions/select_option.dart';
// import 'package:sunny_forms/sunny_form_field.dart';
// import 'package:sunny_forms/theme/sunny_icons.dart';
//
// final _allContactTypes = <Option<String>>[
//   ...contactableTypeOptions,
//   ...Providers.socialProviderOptions,
// ].keyed((_) => _.key);
//
// class ReachOutTypeHintField extends StatelessWidget {
//   final JsonPath attribute;
//   final String label;
//   final String placeholder;
//   final bool isRequired;
//
//   ReachOutTypeHintField(
//       {Key key,
//       @required this.attribute,
//       @required this.isRequired,
//       String label,
//       String placeholder})
//       : label = label ?? "How should you reach out?",
//         placeholder = placeholder ?? "Choose an option, or type a custom value",
//         super(key: key);
//
//   @override
//   Widget build(BuildContext context) {
//     return AttributeFormField<String>(
//       label: label,
//       isRequired: isRequired,
//       placeholder: placeholder,
//       attribute: attribute,
//       builder: (context, fieldState) {
//         return ReachOutTypeHintControl(
//           placeholder: placeholder,
//           fieldState: fieldState,
//         );
//       },
//     );
//   }
// }
//
// class ReachOutTypeHintControl extends StatelessWidget {
//   final String placeholder;
//   final SunnyFormFieldState<String> fieldState;
//
//   ReachOutTypeHintControl({Key key, String placeholder, this.fieldState})
//       : placeholder = placeholder ?? "Choose an option, or type a custom value",
//         super(key: key);
//
//   @override
//   Widget build(BuildContext context) {
//     return OptionSelectorControl<String, String>(
//       placeholder: placeholder,
//       isRequired: false,
//       viewHandler: TypeaheadHandler.defaults(
//           showExpand: true,
//           prefixIcon: SunnyIcons.reachOut.icon,
//           focusMode: TypeaheadFocusMode.showAll),
//       initialValue: fieldState.value,
//       onChange: (option, source) => fieldState.updateValue(option?.key, source),
//       handler: OptionsHandler<String>.ofList(
//         Definitions.sunnyReachOutType.baseCode,
//         canShowAll: true,
//         allOptions: _allContactTypes.keys.toList(),
//         toOption: (key) => _allContactTypes[key],
//         adhocOptionsBuilder: (query) => AdhocOption.ofString(query),
//         inputIcon: SunnyIcons.phone.icon,
//         placeholder: placeholder,
//       ),
//       onError: (error) {
//         fieldState.error = error;
//       },
//     );
//   }
// }
//
// class ReachOutTypePropertyHandler extends MetaPropertyHandler {
//   ReachOutTypePropertyHandler();
//
//   @override
//   Iterable<Widget> renderProperty(
//     BuildContext context,
//     MetaFormContext metaForm,
//     HandledPaths paths,
//     SunnyFormFieldState state, {
//     Key key,
//   }) {
//     final prop =
//         paths.paths.values.firstOrNull ?? metaForm.schema.getByPath(paths.path);
//     return [
//       ReachOutTypeHintControl(
//         key: key,
//         fieldState: state.cast(),
//       )
//     ];
//   }
//
//   @override
//   Iterable<HandledPaths> acceptProperties(JsonPath basePath,
//       IMSchemaDefinition definition, Map<JsonPath, IMSchemaProperty> available) {
//     return available
//         .filterEntries(
//             (k, v) => "${v.uri}" == Definitions.sunnyReachOutType.uri)
//         .mapEntries((k, v) => HandledPaths.ofProperty(v, basePath, this));
//   }
// }
